package com.trainerplan.trainerplan;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.os.AsyncTask;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.Toast;

import com.trainerplan.trainerplan.modelo.Entrenamientos;
import com.trainerplan.trainerplan.modelo.PlanesEntrenamiento;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;

public class Agregar extends AppCompatActivity {


    //Nos permite almacenar de forma persistentes los datos de los usuarios
    SharedPreferences prefs;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_agregar);


        Button generar = (Button) findViewById(R.id.generar);
        Button nuevo = (Button) findViewById(R.id.nuevo);
        Button buscar = (Button) findViewById(R.id.buscar);
        Button importar = (Button) findViewById(R.id.importar);


        generar.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View view) {

                SharedPreferences prefs = getSharedPreferences("MisPreferencias",Context.MODE_PRIVATE);
                SharedPreferences.Editor editor = prefs.edit();
                editor.putString("tiponuevo", "generar");
                editor.commit();

                Intent intent = new Intent(Agregar.this, Nuevo.class);
                startActivity(intent);

            }

        });

        nuevo.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View view) {

                SharedPreferences prefs = getSharedPreferences("MisPreferencias",Context.MODE_PRIVATE);
                SharedPreferences.Editor editor = prefs.edit();
                editor.putString("tiponuevo", "obtener");
                editor.commit();

                Intent intent = new Intent(Agregar.this, Nuevo.class);
                startActivity(intent);
            }

        });

        buscar.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View view) {
                Intent intent = new Intent(Agregar.this, Buscar.class);
                startActivity(intent);

            }

        });

        importar.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View view) {

                SharedPreferences prefs = getSharedPreferences("MisPreferencias", Context.MODE_PRIVATE);
                String idusuario, sesion, email;
                idusuario = (prefs.getString("idusuario", ""));
                sesion = (prefs.getString("sesion", ""));
                email = (prefs.getString("email", ""));


                if (idusuario.isEmpty()) {


                    /// Si no soy usuario registrado no puedo compartir
                    AlertDialog.Builder alertDialogBuilder3 = new AlertDialog.Builder(Agregar.this);
                    // set title
                    alertDialogBuilder3.setTitle(getBaseContext().getString(R.string.para_importar_registrado));
                    // set dialog message
                    alertDialogBuilder3
                            .setMessage(getBaseContext().getString(R.string.deseas_autentificarte)
                            )
                            .setCancelable(false)
                            .setPositiveButton(getBaseContext().getString(R.string.si), new DialogInterface.OnClickListener() {
                                public void onClick(DialogInterface dialog, int id) {
                                    // if this button is clicked, close
                                    // current activity
                                    Intent intent6 = new Intent(Agregar.this, Validar.class);
                                    startActivity(intent6);
                                }
                            })


                            .setNegativeButton(getBaseContext().getString(R.string.no), new DialogInterface.OnClickListener() {
                                public void onClick(DialogInterface dialog, int id) {
                                    // if this button is clicked, just close
                                    // the dialog box and do nothing
                                    dialog.cancel();
                                }
                            });
                    // create alert dialog
                    AlertDialog alertDialog2 = alertDialogBuilder3.create();
                    alertDialogBuilder3.show();


                }
                else {
                    if (new CheckearConexion(Agregar.this).isNetworkAvailable()) {
                        Toast.makeText(Agregar.this, getString(R.string.importando), Toast.LENGTH_SHORT).show();
                        Agregar.obtenerPlanesImportar obtenerplan = new Agregar.obtenerPlanesImportar(Agregar.this);
                        String urlbase;
                        urlbase = (prefs.getString("urlbase", ""));
                        obtenerplan.execute(urlbase + "importar.php", idusuario, sesion, email);
                        Intent intent = new Intent(Agregar.this, Planes.class);
                    } else {
                        Toast.makeText(Agregar.this, getString(R.string.error_conexion), Toast.LENGTH_LONG).show();
                    }
                }



            }

        });




    }



    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.nuevo_activity_menu, menu);
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {

            case R.id.action_listado:
                Intent intent2 = new Intent(Agregar.this, Planes.class);
                startActivity(intent2);
                return true;

            case R.id.action_salir:
                // Quitamos el valor de las variables guardadas de forma persistente
                prefs = getSharedPreferences("MisPreferencias", Context.MODE_PRIVATE);
                SharedPreferences.Editor editor = prefs.edit();
                editor.putString("idrespuesta", "");
                editor.putString("email", "");
                editor.putString("idusuario", "");
                editor.putString("sesion", "");
                editor.commit();
                Intent intent3 = new Intent(Agregar.this, Validar.class);
                startActivity(intent3);
                return true;

            default:
                return super.onOptionsItemSelected(item);

        }



    }



    // Obtener Planes a importar

    public class obtenerPlanesImportar extends AsyncTask<String, String, String> {


        //Bara de progresión
        private ProgressDialog dialog;


        public obtenerPlanesImportar (Agregar activity) {

            // Definimos la barra de progresión
            dialog = new ProgressDialog(activity);


        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            // Mostramos la barra de progresión
            dialog.setMessage(getString(R.string.obteniendo_plan));
            dialog.show();

        }


        @Override
        protected String doInBackground(String... params) {


            String urlString = params[0]; // URL to call

            String resultToDisplay = "";
            OutputStreamWriter request = null;

            InputStream in = null;
            try {

                URL url = new URL(urlString);
                String parameters = "idusuario=" + params[1] + "&sesion=" + params[2] + "&email=" + params[3];


                HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
                urlConnection.setDoOutput(true);
                urlConnection.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
                urlConnection.setRequestMethod("POST");

                request = new OutputStreamWriter(urlConnection.getOutputStream());
                request.write(parameters);
                request.flush();
                request.close();


                in = new BufferedInputStream(urlConnection.getInputStream());

                BufferedReader br = new BufferedReader(new InputStreamReader(in));
                String inputLine = "";
                while ((inputLine = br.readLine()) != null) {
                    resultToDisplay += inputLine;

                }

                trataJSON(resultToDisplay);


            } catch (Exception e) {

                System.out.println(e.getMessage());

                return e.getMessage();

            }




            //return resultToDisplay;
            return "";
        }

        @Override
        protected void onPostExecute(String result) {
            super.onPostExecute(result);
            dialog.dismiss();
            if (!result.isEmpty())  {
                Toast.makeText(Agregar.this, getString(R.string.error_conexion_servidor)+" "+ result, Toast.LENGTH_LONG).show();

            }

        }


    }


    /// Obtenemos el json y lo cargamos en nuestra BBDDD Local
    private void trataJSON(String result) {


        Log.d("AAAA", result);
        JSONArray jsonArray = null;
        try {
            jsonArray = new JSONArray(result);
            for (int i = 0; i < jsonArray.length(); i++) {
                JSONObject obj1 = jsonArray.getJSONObject(i);
                String idplan = (String) obj1.get("idplan");
                String nombreplan = (String) obj1.get("nombre");
                String tipo = (String) obj1.get("tipo");
                String fecha = (String) obj1.get("fecha");
                String tiempo = (String) obj1.get("tiempo");
                String lang = (String) obj1.get("lang");

                PlanesEntrenamiento plan1 = new PlanesEntrenamiento(Integer.parseInt(idplan), nombreplan, fecha, tiempo, Integer.parseInt(tipo), lang);
                plan1.save();

                JSONArray entrenamientos = obj1.getJSONArray("entrenamientos");
                for (int j = 0; j < entrenamientos.length(); j++) {
                    Log.e("SEMANA", j + "");
                    String semana = entrenamientos.getJSONObject(j).getString("semana");
                    String entrenamiento = entrenamientos.getJSONObject(j).getString("entrenamiento");
                    Entrenamientos entrenamiento1 = new Entrenamientos(Integer.parseInt(semana), entrenamiento, plan1);
                    entrenamiento1.save();

                }
                Intent intent = new Intent(Agregar.this, Planes.class);
                startActivity(intent);

            }
        } catch (JSONException e) {
            e.printStackTrace();

        }
    }


}


