package com.trainerplan.trainerplan;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.net.Uri;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Toast;

import com.google.android.gms.appindexing.Action;
import com.google.android.gms.appindexing.AppIndex;
import com.google.android.gms.appindexing.Thing;
import com.google.android.gms.common.api.GoogleApiClient;
import com.trainerplan.trainerplan.modelo.Entrenamientos;
import com.trainerplan.trainerplan.modelo.PlanesEntrenamiento;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;


public class Buscar extends AppCompatActivity {

    /////////////// LISTADO DE PLANES
    ListViewAdapterBuscar adapter;

    ArrayList<Integer> idplanes = new ArrayList<Integer>();
    ArrayList<String> idiomas = new ArrayList<String>();
    ArrayList<String> nombres = new ArrayList<String>();
    ArrayList<String> tipos = new ArrayList<String>();
    ArrayList<String> usuarios = new ArrayList<String>();
    ArrayList<String> fechas = new ArrayList<String>();
    ArrayList<String> tiempos = new ArrayList<String>();


    //Nos permite almacenar de forma persistentes los datos de los usuarios
    SharedPreferences prefs;

    Button btBuscar;
    EditText txNombre, txUsuario, txIdioma;
    /**
     * ATTENTION: This was auto-generated to implement the App Indexing API.
     * See https://g.co/AppIndexing/AndroidStudio for more information.
     */
    private GoogleApiClient client;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_buscar);
        //Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);




        if (new CheckearConexion(Buscar.this).isNetworkAvailable()) {
            //// Listado planes
            buscarPlanes buscarPlanes = new buscarPlanes(Buscar.this, this);
            //buscarPlanes.execute("https://www.trainerplan.com/app/compartir.php", "", plan.getNombreplan(), plan.getFecha(), plan.getTiempoobjetivo(), tipo.toString(), idusuario, email, sesion, lang, json);

            // Obtenemos la url base
            SharedPreferences prefs = getSharedPreferences("MisPreferencias", Context.MODE_PRIVATE);
            String urlbase;
            urlbase = (prefs.getString("urlbase", ""));
            buscarPlanes.execute(urlbase+"buscar.php", "", "", "");

        } else {
            Toast.makeText(Buscar.this, getString(R.string.error_conexion), Toast.LENGTH_LONG).show();
        }


        btBuscar = (Button) findViewById(R.id.btBuscar);
        txNombre = (EditText) findViewById(R.id.etNombre);
        txUsuario = (EditText) findViewById(R.id.etUsuario);
        txIdioma = (EditText) findViewById(R.id.etIdioma);


        btBuscar.setFocusableInTouchMode(true);
        btBuscar.requestFocus();

        btBuscar.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View view) {

                if (new CheckearConexion(Buscar.this).isNetworkAvailable()) {
                    buscarPlanes buscarPlanes = new buscarPlanes(Buscar.this, getBaseContext());
                    // Obtenemos la url base
                    SharedPreferences prefs = getSharedPreferences("MisPreferencias", Context.MODE_PRIVATE);
                    String urlbase;
                    urlbase = (prefs.getString("urlbase", ""));
                    buscarPlanes.execute(urlbase+"buscar.php", txNombre.getText().toString(), txUsuario.getText().toString(), txIdioma.getText().toString());

                } else {
                    Toast.makeText(Buscar.this, getString(R.string.error_conexion), Toast.LENGTH_LONG).show();
                }

                          }

        });



        //Obtenemos el listado de todos los planes de nuestra base de datos


        // ATTENTION: This was auto-generated to implement the App Indexing API.
        // See https://g.co/AppIndexing/AndroidStudio for more information.
        client = new GoogleApiClient.Builder(this).addApi(AppIndex.API).build();
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.buscar_activity_menu, menu);
        return super.onCreateOptionsMenu(menu);


    }







    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {

            case R.id.action_listado:
                Intent intent3 = new Intent(Buscar.this, Planes.class);
                startActivity(intent3);
                return true;

            case R.id.action_salir:
                // Quitamos el valor de las variables guardadas de forma persistente
                prefs = getSharedPreferences("MisPreferencias", Context.MODE_PRIVATE);
                SharedPreferences.Editor editor = prefs.edit();
                editor.putString("idrespuesta", "");
                editor.putString("email", "");
                editor.putString("idusuario", "");
                editor.putString("sesion", "");
                editor.commit();

                Intent intent4 = new Intent(Buscar.this, Validar.class);
                startActivity(intent4);
                return true;


            default:
                return super.onOptionsItemSelected(item);

        }
    }

    /**
     * ATTENTION: This was auto-generated to implement the App Indexing API.
     * See https://g.co/AppIndexing/AndroidStudio for more information.
     */
    public Action getIndexApiAction() {
        Thing object = new Thing.Builder()
                .setName("Buscar Page") // TODO: Define a title for the content shown.
                // TODO: Make sure this auto-generated URL is correct.
                .setUrl(Uri.parse("http://[ENTER-YOUR-URL-HERE]"))
                .build();
        return new Action.Builder(Action.TYPE_VIEW)
                .setObject(object)
                .setActionStatus(Action.STATUS_TYPE_COMPLETED)
                .build();
    }

    @Override
    public void onStart() {
        super.onStart();

        // ATTENTION: This was auto-generated to implement the App Indexing API.
        // See https://g.co/AppIndexing/AndroidStudio for more information.
        client.connect();
        AppIndex.AppIndexApi.start(client, getIndexApiAction());
    }

    @Override
    public void onStop() {
        super.onStop();

        // ATTENTION: This was auto-generated to implement the App Indexing API.
        // See https://g.co/AppIndexing/AndroidStudio for more information.
        AppIndex.AppIndexApi.end(client, getIndexApiAction());
        client.disconnect();
    }

    // Elsiguiente método comparte un plan de forma asíncrona

    public class buscarPlanes extends AsyncTask<String, String, String> {


        //Bara de progresión
        private ProgressDialog dialog;

        private Context mContext;

        public buscarPlanes(Buscar activity, Context context) {
            // Definimos la barra de progresión
            dialog = new ProgressDialog(activity);
            mContext = context;

        }


        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            // Mostramos la barra de progresión
            dialog.setMessage(getString(R.string.buscando_plan));
            dialog.show();
        }


        @Override
        protected String doInBackground(String... params) {


            String urlString = params[0]; // URL to call

            String resultToDisplay = "";
            OutputStreamWriter request = null;

            InputStream in = null;
            try {

                URL url = new URL(urlString);

                String parameters = "&nombre=" + params[1] + "&usuario=" + params[2] + "&lang=" + params[3];


                HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
                urlConnection.setDoOutput(true);
                urlConnection.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
                urlConnection.setRequestMethod("POST");

                request = new OutputStreamWriter(urlConnection.getOutputStream());
                request.write(parameters);
                request.flush();
                request.close();


                in = new BufferedInputStream(urlConnection.getInputStream());

                BufferedReader br = new BufferedReader(new InputStreamReader(in));
                String inputLine = "";
                while ((inputLine = br.readLine()) != null) {
                    resultToDisplay += inputLine;

                }

                resultToDisplay = trataJSONPlanes(resultToDisplay);


            } catch (Exception e) {

                System.out.println(e.getMessage());


                return e.getMessage();

            }


            return resultToDisplay;
        }


        @Override
        protected void onPostExecute(String result) {

            // Finalizamos la barra de progresión
            if (dialog.isShowing()) {
                dialog.dismiss();
            }

            if (result.equals("1")) {
                Toast.makeText(getBaseContext(), getString(R.string.plan_encontrado), Toast.LENGTH_LONG).show();

            } else {
                Toast.makeText(getBaseContext(), getString(R.string.plan_no_encontrado), Toast.LENGTH_LONG).show();
            }

            final ListView lista = (ListView) findViewById(R.id.listView1);

            adapter = new ListViewAdapterBuscar(mContext, idplanes, nombres, idiomas, tipos, usuarios, fechas, tiempos);
            lista.setAdapter(adapter);


            lista.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                @Override
                public void onItemClick(AdapterView adapterView, View view, int i, long l) {


                    if (new CheckearConexion(Buscar.this).isNetworkAvailable()) {
                        cargarPlan cargarPlan = new cargarPlan(Buscar.this);
                        // Obtenemos la url base
                        SharedPreferences prefs = getSharedPreferences("MisPreferencias", Context.MODE_PRIVATE);
                        String urlbase;
                        urlbase = (prefs.getString("urlbase", ""));
                        cargarPlan.execute(urlbase+"cargar.php", idplanes.get(i).toString());
                        //Intent intent = new Intent(Buscar.this, Planes.class);
                        //startActivity(intent);
                    } else {
                        Toast.makeText(Buscar.this, getString(R.string.error_conexion), Toast.LENGTH_LONG).show();
                    }


                }
            });

        }
    }


    private String trataJSONPlanes(String result) {


        idplanes.clear();
        idiomas.clear();
        nombres.clear();
        tipos.clear();
        usuarios.clear();
        fechas.clear();
        tiempos.clear();

        JSONArray jsonArray = null;
        try {
            jsonArray = new JSONArray(result);
            for (int i = 0; i < jsonArray.length(); i++) {
                JSONObject obj1 = jsonArray.getJSONObject(i);
                String idplan = (String) obj1.get("idplan");
                String nombre = (String) obj1.get("nombre");
                String idioma = (String) obj1.get("lang");
                String tipo = (String) obj1.get("tipo");
                String usuario = (String) obj1.get("usuario");
                String fecha = (String) obj1.get("fecha");
                String tiempo = (String) obj1.get("tiempo");

                idplanes.add(Integer.parseInt(idplan));
                idiomas.add(idioma);
                nombres.add(nombre);
                tipos.add(tipo);
                usuarios.add(usuario);
                fechas.add(fecha);
                tiempos.add(tiempo);


            }

        } catch (JSONException e) {
            e.printStackTrace();
        }

        if (nombres.size() > 0)
            return "1";
        else
            return "0";
    }


    ///////// Carga el plan de forma asíncrona

    public class cargarPlan extends AsyncTask<String, String, String> {


        //Bara de progresión
        private ProgressDialog dialog;

        private Context mContext;

        public cargarPlan(Buscar activity) {
            // Definimos la barra de progresión
            dialog = new ProgressDialog(activity);

        }


        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            // Mostramos la barra de progresión
            dialog.setMessage(getString(R.string.obteniendo_plan));
            dialog.show();
        }


        @Override
        protected String doInBackground(String... params) {


            String urlString = params[0]; // URL to call

            String resultToDisplay = "";
            OutputStreamWriter request = null;

            InputStream in = null;
            try {

                URL url = new URL(urlString);

                String parameters = "&idplan=" + params[1];

                HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
                urlConnection.setDoOutput(true);
                urlConnection.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
                urlConnection.setRequestMethod("POST");

                request = new OutputStreamWriter(urlConnection.getOutputStream());
                request.write(parameters);
                request.flush();
                request.close();


                in = new BufferedInputStream(urlConnection.getInputStream());

                BufferedReader br = new BufferedReader(new InputStreamReader(in));
                String inputLine = "";
                while ((inputLine = br.readLine()) != null) {
                    resultToDisplay += inputLine;

                }

                resultToDisplay = trataJSON(resultToDisplay);


            } catch (Exception e) {

                System.out.println(e.getMessage());


                return e.getMessage();

            }


            return resultToDisplay;
        }


        @Override
        protected void onPostExecute(String result) {

            // Finalizamos la barra de progresión
            if (dialog.isShowing()) {
                dialog.dismiss();
            }

            if (result.equals("1")) {
                Toast.makeText(getBaseContext(), getString(R.string.plan_cargado), Toast.LENGTH_LONG).show();


            } else {
                Toast.makeText(getBaseContext(), getString(R.string.plan_no_cargado), Toast.LENGTH_LONG).show();
            }



        }
    }


    /// Importa el plan seleccionado entre los buscados
    private String trataJSON(String result) {


        Log.d("DDDDDDD", result);

        JSONArray jsonArray = null;
        try {
            jsonArray = new JSONArray(result);
            for (int i = 0; i < jsonArray.length(); i++) {
                JSONObject obj1 = jsonArray.getJSONObject(i);
                String idplan = (String) obj1.get("idplan");
                String nombreplan = (String) obj1.get("nombre");
                String tipo = (String) obj1.get("tipo");
                String fecha = (String) obj1.get("fecha");
                String tiempo = (String) obj1.get("tiempo");
                String lang = (String) obj1.get("lang");

                PlanesEntrenamiento plan1 = new PlanesEntrenamiento(Integer.parseInt(idplan), nombreplan, fecha, tiempo, Integer.parseInt(tipo), lang);
                plan1.save();

                JSONArray entrenamientos = obj1.getJSONArray("entrenamientos");
                for (int j = 0; j < entrenamientos.length(); j++) {
                    Log.e("SEMANA", j + "");
                    String semana = entrenamientos.getJSONObject(j).getString("semana");
                    String entrenamiento = entrenamientos.getJSONObject(j).getString("entrenamiento");
                    Entrenamientos entrenamiento1 = new Entrenamientos(Integer.parseInt(semana), entrenamiento, plan1);
                    entrenamiento1.save();

                }
                Intent intent = new Intent(Buscar.this, Planes.class);
                startActivity(intent);

            }
        } catch (JSONException e) {
            e.printStackTrace();
        }
        return "1";
    }
}



