package com.trainerplan.trainerplan;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.ArrayList;


// Adaptador utilizado para cargar la lista de Planes
public class ListViewAdapterBuscar extends BaseAdapter {
    // Declare Variables
    Context context;
    ArrayList<Long> ids;
    ArrayList<Integer> idplanes;
    ArrayList<String> nombres;
    ArrayList<String> idiomas;
    ArrayList<String> tipos;
    ArrayList<String> usuarios;
    ArrayList<String> fechas;
    ArrayList<String> tiempos;


    LayoutInflater inflater;

    public ListViewAdapterBuscar(Context context,  ArrayList<Integer> idplanes, ArrayList<String> nombres, ArrayList<String> idiomas, ArrayList<String> tipos, ArrayList<String> usuarios, ArrayList<String> fechas, ArrayList<String> tiempos) {
        this.context = context;
        this.idplanes = idplanes;
        this.nombres = nombres;
        this.idiomas = idiomas;
        this.tipos = tipos;
        this.usuarios = usuarios;
        this.fechas = fechas;
        this.tiempos = tiempos;

    }

    @Override
    public int getCount() {
        return nombres.size();
    }

    @Override
    public Object getItem(int position) {
        return null;
    }

    @Override
    public long getItemId(int position) {
        return 0;
    }

    public View getView(int position, View convertView, ViewGroup parent) {

        TextView nombreplan,fechaplan,usuarioplan;
        ImageView imagenplan;

        inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);

        View itemView = inflater.inflate(R.layout.list_row_buscar, parent, false);

        nombreplan = (TextView) itemView.findViewById(R.id.nombre_row_plan);
        fechaplan = (TextView) itemView.findViewById(R.id.fecha_row_plan);
        usuarioplan = (TextView) itemView.findViewById(R.id.usuario_row_plan);
        imagenplan = (ImageView) itemView.findViewById(R.id.imagen_row_plan);


        String strtiempo = "", strhoras = "", strminutos = "";

        // En lugar de utilizar 3 líneas pongo todos los datos en 1.
        if (!tiempos.equals("")) {
            int horas = Integer.parseInt("0"+tiempos.get(position).split(":")[0]);
            int minutos = Integer.parseInt("0"+tiempos.get(position).split(":")[1]);
            if (horas != 0 || minutos != 0) {
                if (horas != 0)
                    strhoras = horas + " " + context.getString(R.string.horas);
                if (strhoras != "" && minutos != 0)
                    strminutos = " "+context.getString(R.string.y) + " " + minutos + " " + context.getString(R.string.minutos);
                else
                    strminutos = " " + minutos + " " + context.getString(R.string.minutos);

                strtiempo = context.getString(R.string.en) + " " + strhoras + strminutos;

            }
        }



        // Carga de las rows con los valores
        nombreplan.setText(nombres.get(position)+" "+ strtiempo );
        fechaplan.setText((context.getString(R.string.usuario))+": "+(usuarios.get(position)+" ")+(context.getString(R.string.idioma))+": "+(idiomas.get(position)+" "));
        usuarioplan.setText(context.getString(R.string.fecha)+ fechas.get(position));

        // Dependiendo del tipo de plan cargamos una imagen u otra.
        switch (Integer.parseInt(tipos.get(position))) {
            case 0:
            case 1:
            case 2:
            case 3:
                imagenplan.setImageResource(R.drawable.atletismo);
                break;
            case 4:
            case 5:
            case 6:
            case 7:
                imagenplan.setImageResource(R.drawable.triatlon);
                break;
            case 8:
                imagenplan.setImageResource(R.drawable.natacion);
                break;
            case 9:
                imagenplan.setImageResource(R.drawable.ciclismo);
                break;
            case 10:
                imagenplan.setImageResource(R.drawable.montana);
                break;
            default:
                imagenplan.setImageResource(R.drawable.atletismo);
                break;
        }


        return itemView;
    }
}