package com.trainerplan.trainerplan;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.trainerplan.trainerplan.modelo.Entrenamientos;
import com.trainerplan.trainerplan.modelo.PlanesEntrenamiento;

// Creamos un entrenamiento semanal, modificamos o borramos uno ya existente
public class NuevaSemana extends AppCompatActivity {

    //Nos permite almacenar de forma persistentes los datos de los usuarios
    SharedPreferences prefs;

    EditText semana, dia1, dia2, dia3, dia4, dia5, dia6, dia7;
    String semanatxt, dia1txt, dia2txt, dia3txt, dia4txt, dia5txt, dia6txt, dia7txt;

    public String idplan = "", identrenamiento = "";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_nueva_semana);


        semana = (EditText) findViewById(R.id.semana);
        dia1 = (EditText) findViewById(R.id.dia1);
        dia2 = (EditText) findViewById(R.id.dia2);
        dia3 = (EditText) findViewById(R.id.dia3);
        dia4 = (EditText) findViewById(R.id.dia4);
        dia5 = (EditText) findViewById(R.id.dia5);
        dia6 = (EditText) findViewById(R.id.dia6);
        dia7 = (EditText) findViewById(R.id.dia7);


        final Button btGuardar = (Button) findViewById(R.id.guardarsemana);

        btGuardar.setFocusableInTouchMode(true);
        btGuardar.requestFocus();
        /////// Si tenemos el identrenamiento entonces vamos a MODIFICAR
        Intent intent = getIntent();
        Bundle extras = intent.getExtras();


        if (extras != null) {
            idplan = (String) extras.get("idplan");
            identrenamiento = (String) extras.get("identrenamiento");

        }

        //SharedPreferences prefs = getSharedPreferences("MisPreferencias", Context.MODE_PRIVATE);
        //String identrenamiento = (prefs.getString("identrenamiento", ""));

        if (!identrenamiento.isEmpty()) {
            Entrenamientos entrenamiento = Entrenamientos.findById(Entrenamientos.class, Integer.parseInt(identrenamiento));
            semana.setText(entrenamiento.getSemana() + "");
            dia1.setText(entrenamiento.getEntrenamiento().replace("|", "| ").split("\\|")[0].trim());
            dia2.setText(entrenamiento.getEntrenamiento().replace("|", "| ").split("\\|")[1].trim());
            dia3.setText(entrenamiento.getEntrenamiento().replace("|", "| ").split("\\|")[2].trim());
            dia4.setText(entrenamiento.getEntrenamiento().replace("|", "| ").split("\\|")[3].trim());
            dia5.setText(entrenamiento.getEntrenamiento().replace("|", "| ").split("\\|")[4].trim());
            dia6.setText(entrenamiento.getEntrenamiento().replace("|", "| ").split("\\|")[5].trim());
            dia7.setText(entrenamiento.getEntrenamiento().replace("|", "| ").split("\\|")[6].trim());
            btGuardar.setText(getString(R.string.modificar));
            getSupportActionBar().setTitle(getString(R.string.modificar));


        }

        btGuardar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {


                semanatxt = semana.getText().toString();
                dia1txt = dia1.getText().toString();
                dia2txt = dia2.getText().toString();
                dia3txt = dia3.getText().toString();
                dia4txt = dia4.getText().toString();
                dia5txt = dia5.getText().toString();
                dia6txt = dia6.getText().toString();
                dia7txt = dia7.getText().toString();



                if (semanatxt.isEmpty()) {
                    Toast.makeText(NuevaSemana.this, getString(R.string.obligatorio_semana), Toast.LENGTH_SHORT).show();
                } else {

                    /// Modificar semana de entrenamiento
                    if (btGuardar.getText().equals(getString(R.string.modificar))) {
                        PlanesEntrenamiento plan = PlanesEntrenamiento.findById(PlanesEntrenamiento.class, Integer.parseInt(idplan));
                        Entrenamientos entrenamiento = Entrenamientos.findById(Entrenamientos.class, Integer.parseInt(identrenamiento));
                        entrenamiento.ModificarEntrenamiento(Integer.parseInt(identrenamiento), Integer.parseInt(semanatxt), dia1txt + "|" + dia2txt + "|" + dia3txt + "|" + dia4txt + "|" + dia5txt + "|" + dia6txt + "|" + dia7txt, plan);


                    } else {
                        /// Añadimos semana de entrenamiento
                        PlanesEntrenamiento plan = PlanesEntrenamiento.findById(PlanesEntrenamiento.class, Integer.parseInt(idplan));
                        Entrenamientos entrenamiento1 = new Entrenamientos(Integer.parseInt(semanatxt), dia1txt + "|" + dia2txt + "|" + dia3txt + "|" + dia4txt + "|" + dia5txt + "|" + dia6txt + "|" + dia7txt, plan);
                        entrenamiento1.save();
                    }

                    Intent intent2 = new Intent(NuevaSemana.this, PlanesSemanales.class);
                    intent2.putExtra("idplan", idplan);
                    startActivity(intent2);



                }

            }
        });

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.nuevo_activity_menu, menu);
        return super.onCreateOptionsMenu(menu);


    }
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.action_listado:
                Intent intent2 = new Intent(NuevaSemana.this, Planes.class);
                startActivity(intent2);
                return true;

            case R.id.action_salir:
                // Quitamos el valor de las variables guardadas de forma persistente
                prefs = getSharedPreferences("MisPreferencias", Context.MODE_PRIVATE);
                SharedPreferences.Editor editor = prefs.edit();
                editor.putString("idrespuesta", "");
                editor.putString("email", "");
                editor.putString("idusuario", "");
                editor.putString("sesion", "");
                editor.commit();
                Intent intent3 = new Intent(NuevaSemana.this, Validar.class);
                startActivity(intent3);
                return true;

            default:
                return super.onOptionsItemSelected(item);

        }
    }
}