package com.trainerplan.trainerplan;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import com.trainerplan.trainerplan.modelo.Entrenamientos;
import com.trainerplan.trainerplan.modelo.PlanesEntrenamiento;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Locale;

public class Nuevo extends AppCompatActivity {


    private EditText fecha;

    private EditText horas;

    private EditText minutos;

    private EditText nombre;

    private Spinner tipoplan;

    String fechatxt, tiempotxt, nombretxt, tipoplantxt;
    String idplan="";

    //Nos permite almacenar de forma persistentes los datos de los usuarios
    SharedPreferences prefs;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_nuevo);
        //Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);








        // Programamos el spinner de la fecha
        tipoplan = (Spinner) findViewById(R.id.tipoplan);
        ArrayAdapter spinner_adapter = ArrayAdapter.createFromResource( this, R.array.array_planes , android.R.layout.simple_spinner_item);
        spinner_adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        tipoplan.setAdapter(spinner_adapter);



        // Haciendo click obtener la fecha
        fecha = (EditText) findViewById(R.id.fecha);
        horas = (EditText) findViewById(R.id.horas);
        minutos = (EditText) findViewById(R.id.minutos);
        nombre = (EditText) findViewById(R.id.nombre);


        final Button btNuevoPlan = (Button) findViewById(R.id.obtenernuevoplan);


        btNuevoPlan.setFocusableInTouchMode(true);
        btNuevoPlan.requestFocus();

        /////// Si tenemos el idplan entonces vamos a MODIFICAR
        Intent intent = getIntent();
        Bundle extras = intent.getExtras();

        if (extras != null)
            idplan =  (String) extras.get("idplan");

        if (!idplan.isEmpty()) {
            PlanesEntrenamiento plan = PlanesEntrenamiento.findById(PlanesEntrenamiento.class, Integer.parseInt(idplan));
            fecha.setText(plan.getFecha());
            nombre.setText(plan.getNombreplan());
            horas.setText(plan.getTiempoobjetivo().split(":")[0]);
            minutos.setText(plan.getTiempoobjetivo().split(":")[1]);
            // Colocamos el tipo en el spinner
            tipoplan.setSelection(plan.getTipo());

            btNuevoPlan.setText(getString(R.string.modificar_plan));
            getSupportActionBar().setTitle(getString(R.string.modificar_plan));


        }
        /////////////// Fin modificar


        btNuevoPlan.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {


                int strhoras,strminutos;
                nombretxt=nombre.getText().toString();
                fechatxt=fecha.getText().toString();
                if (horas.getText().toString().equals(""))
                    strhoras=0;
                    else
                    strhoras=Integer.parseInt(horas.getText().toString());
                if (minutos.getText().toString().equals(""))
                    strminutos=0;
                else
                    strminutos=Integer.parseInt(minutos.getText().toString());

                tiempotxt=strhoras+":"+strminutos;
                tipoplantxt=tipoplan.getSelectedItemPosition()+"";

                String lang = Locale.getDefault().getLanguage().toString();


                if (nombretxt.isEmpty()) {
                    nombre.requestFocus();
                    Toast.makeText(Nuevo.this, getString(R.string.nombre_obligatorio), Toast.LENGTH_SHORT).show();
                } else if (fechatxt.isEmpty()) {
                    fecha.requestFocus();
                    Toast.makeText(Nuevo.this, getString(R.string.fecha_obligatoria), Toast.LENGTH_SHORT).show();
                    /*
                } else if (horas.getText().toString().isEmpty()) {
                    horas.requestFocus();
                    Toast.makeText(Nuevo.this, "Es obligatorio introducir los horas", Toast.LENGTH_SHORT).show();
                } else if (minutos.getText().toString().isEmpty()) {
                    minutos.requestFocus();
                    Toast.makeText(Nuevo.this, "Es obligatorio introducir los minutos", Toast.LENGTH_SHORT).show();
                    */
                }
                else {
                    /// MODIFICAR Plan
                    if (btNuevoPlan.getText().equals(getString(R.string.modificar_plan))) {
                        PlanesEntrenamiento plan = PlanesEntrenamiento.findById(PlanesEntrenamiento.class, Integer.parseInt(idplan));
                        plan.ModificarPlanEntrenamiento(Integer.parseInt(idplan), nombretxt, fechatxt, tiempotxt, Integer.parseInt(tipoplantxt), lang);
                        Intent intent = new Intent(Nuevo.this, Planes.class);
                        startActivity(intent);
                    }
                    //NUEVO Plan
                    else {
                        SharedPreferences prefs = getSharedPreferences("MisPreferencias", Context.MODE_PRIVATE);
                        String tiponuevo = (prefs.getString("tiponuevo", ""));

                        // Obtengo el plan automáticamente
                        if (tiponuevo.equals("generar")) {


                            if (new CheckearConexion(Nuevo.this).isNetworkAvailable()) {
                                obtenerPlan obtenerplan = new obtenerPlan(Nuevo.this);
                                // Obtenemos la url base
                                prefs = getSharedPreferences("MisPreferencias", Context.MODE_PRIVATE);
                                String urlbase;
                                urlbase = (prefs.getString("urlbase", ""));
                                obtenerplan.execute(urlbase+"plan.php", nombretxt, fechatxt, tiempotxt, tipoplantxt, lang);

                            } else {
                                Toast.makeText(Nuevo.this, getString(R.string.error_conexion), Toast.LENGTH_LONG).show();
                            }

                        } else {
                            //Creo el plan manualmente
                            //Toast.makeText(Nuevo.this, Integer.parseInt(idplan)+" "+ nombretxt+" "+ fechatxt+" "+ tiempotxt+" "+ Integer.parseInt(tipoplantxt), Toast.LENGTH_LONG).show();

                            //Toast.makeText(Nuevo.this,   nombretxt+" "+ fechatxt+" "+ tiempotxt+" "+ Integer.parseInt(tipoplantxt), Toast.LENGTH_LONG).show();
                            PlanesEntrenamiento plan = new PlanesEntrenamiento(1, nombretxt, fechatxt, tiempotxt, Integer.parseInt(tipoplantxt), lang);
                            plan.save();
                            Intent intent = new Intent(Nuevo.this, Planes.class);
                            startActivity(intent);
                        }
                    }
                }


            }
        });

        fecha = (EditText) findViewById(R.id.fecha);
        fecha.setKeyListener(null);
        fecha.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                showDatePickerDialog();
            }
        });
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.nuevo_activity_menu, menu);
        return super.onCreateOptionsMenu(menu);

    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.action_listado:
                Intent intent2 = new Intent(Nuevo.this, Planes.class);
                startActivity(intent2);
                return true;

            case R.id.action_salir:
                // Quitamos el valor de las variables guardadas de forma persistente
                prefs = getSharedPreferences("MisPreferencias", Context.MODE_PRIVATE);
                SharedPreferences.Editor editor = prefs.edit();
                editor.putString("idrespuesta", "");
                editor.putString("email", "");
                editor.putString("idusuario", "");
                editor.putString("sesion", "");
                editor.commit();
                Intent intent3 = new Intent(Nuevo.this, Validar.class);
                startActivity(intent3);
                return true;

            default:
                return super.onOptionsItemSelected(item);


        }
    }


    public void showDatePickerDialog() {
        DialogFragment newFragment = new DatePickerFragment();
        newFragment.show(getSupportFragmentManager(), "datePicker");
    }



    // Elsiguiente método obtiene un plan de forma asíncrona

    public class obtenerPlan extends AsyncTask<String, String, String> {


        //Bara de progresión
        private ProgressDialog dialog;


        public obtenerPlan(Nuevo activity) {

            // Definimos la barra de progresión
            dialog = new ProgressDialog(activity);


        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            // Mostramos la barra de progresión
            dialog.setMessage(getString(R.string.obteniendo_plan));
            dialog.show();


        }


        @Override
        protected String doInBackground(String... params) {



            String urlString = params[0]; // URL to call

            String resultToDisplay = "";
            OutputStreamWriter request = null;

            InputStream in = null;
            try {

                URL url = new URL(urlString);
                String parameters = "nombre="+params[1]+"&fecha="+params[2]+"&tiempo="+params[3]+"&tipo="+params[4]+"&lang="+params[5];



                HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
                urlConnection.setDoOutput(true);
                urlConnection.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
                urlConnection.setRequestMethod("POST");

                request = new OutputStreamWriter(urlConnection.getOutputStream());
                request.write(parameters);
                request.flush();
                request.close();



                in = new BufferedInputStream(urlConnection.getInputStream());

                BufferedReader br = new BufferedReader(new InputStreamReader(in));
                String inputLine = "";
                while ((inputLine = br.readLine()) != null) {
                    resultToDisplay+=inputLine;

                }

                trataJSON(resultToDisplay);


            } catch (Exception e) {

                System.out.println(e.getMessage());
                Toast.makeText(getBaseContext(), getString(R.string.compartiendo_plan), Toast.LENGTH_LONG).show();

                return e.getMessage();

            }





            //return resultToDisplay;
            return "";
        }


        @Override
        protected void onPostExecute(String result) {

            // Finalizamos la barra de progresión
            if (dialog.isShowing()) {
                dialog.dismiss();
            }

            if (!result.isEmpty())  {
                Toast.makeText(Nuevo.this, getString(R.string.error_conexion_servidor)+" "+ result, Toast.LENGTH_LONG).show();

            }

        }
    }


    private void trataJSON(String result) {

        JSONArray jsonArray = null;
        try {
            jsonArray = new JSONArray(result);
            for (int i = 0; i < jsonArray.length(); i++) {
                JSONObject obj1 = jsonArray.getJSONObject(i);
                String idplan = (String) obj1.get("idplan");
                String nombreplan = (String) obj1.get("nombre");
                String tipo = (String) obj1.get("tipo");
                String fecha = (String) obj1.get("fecha");
                String tiempo = (String) obj1.get("tiempo");
                String lang = (String) obj1.get("lang");

                PlanesEntrenamiento plan1 = new PlanesEntrenamiento(Integer.parseInt(idplan), nombreplan, fecha, tiempo, Integer.parseInt(tipo), lang);
                plan1.save();

                JSONArray entrenamientos = obj1.getJSONArray("entrenamientos");
                for (int j = 0; j < entrenamientos.length(); j++) {
                    Log.e("SEMANA",j+"");
                    String semana =  entrenamientos.getJSONObject(j).getString("semana");
                    String entrenamiento =  entrenamientos.getJSONObject(j).getString("entrenamiento");
                    Entrenamientos entrenamiento1 = new Entrenamientos(Integer.parseInt(semana), entrenamiento, plan1);
                    entrenamiento1.save();

                }
                Intent intent = new Intent(Nuevo.this, Planes.class);
                startActivity(intent);

            }
        } catch (JSONException e) {
            e.printStackTrace();
        }
    }
}
