package com.trainerplan.trainerplan;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.Toast;

import com.trainerplan.trainerplan.modelo.PlanesEntrenamiento;

import java.util.ArrayList;
import java.util.List;

public class Planes extends AppCompatActivity {


    /////////////// LISTADO DE PLANES
    ListViewAdapterPlanes adapter;

    ArrayList<String> titulo=new ArrayList<String>();
    ArrayList<Long> ids=new ArrayList<Long>();
    ArrayList<Integer> idplanes=new ArrayList<Integer>();
    ArrayList<String> fechas=new ArrayList<String>();
    ArrayList<String> tiempos=new ArrayList<String>();
    ArrayList<Integer> tipos=new ArrayList<Integer>();


    //Nos permite almacenar de forma persistentes los datos de los usuarios
    SharedPreferences prefs;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_planes);


        //Obtenemos el listado de todos los planes de nuestra base de datos

        List<PlanesEntrenamiento> planes = PlanesEntrenamiento.listAll(PlanesEntrenamiento.class);
        // Se coge el primero de la lista de encontrados
        if (!planes.isEmpty()) {
            for (int i =0; i < planes.size(); i++ ) {

                PlanesEntrenamiento plan = planes.get(i);
                ids.add(plan.getId());
                idplanes.add(plan.getIdplan());
                titulo.add(plan.getNombreplan());
                fechas.add(plan.getFecha());
                tiempos.add(plan.getTiempoobjetivo());
                tipos.add(plan.getTipo());

            }

            //}
        }

        //// Listado planes

        final ListView lista = (ListView) findViewById(R.id.listView1);

        adapter = new ListViewAdapterPlanes(this, ids, idplanes, titulo, fechas, tiempos, tipos);
        lista.setAdapter(adapter);

        lista.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView adapterView, View view, int i, long l) {
                Intent intent = new Intent(Planes.this, PlanesSemanales.class);
                intent.putExtra("idplan",ids.get(i)+"");
                startActivity(intent);


            }
        });

}



    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.planes_activity_menu, menu);
        return super.onCreateOptionsMenu(menu);


    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.action_nuevo:
                Intent intent = new Intent(Planes.this, Agregar.class);
                startActivity(intent);
                return true;


            case R.id.action_salir:

                // Quitamos el valor de las variables guardadas de forma persistente
                prefs = getSharedPreferences("MisPreferencias", Context.MODE_PRIVATE);
                SharedPreferences.Editor editor = prefs.edit();
                editor.putString("idrespuesta", "");
                editor.putString("email", "");
                editor.putString("idusuario", "");
                editor.putString("sesion", "");
                editor.commit();

                Intent intent3 = new Intent(Planes.this, Validar.class);
                startActivity(intent3);
                return true;

            default:
                return super.onOptionsItemSelected(item);

        }
    }

}



