package com.trainerplan.trainerplan;

import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.trainerplan.trainerplan.modelo.Entrenamientos;
import com.trainerplan.trainerplan.modelo.PlanesEntrenamiento;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Locale;


// Nos permite visualizar los planes diarios que tenemos que realizar la semana.
public class PlanesDiarios extends AppCompatActivity {


    /////////////// LISTADO DE PLANES
    ListViewAdapterPlanesDiarios adapter;

    ArrayList<Long> ids=new ArrayList<Long>();
    ArrayList<String> dias=new ArrayList<String>();
    ArrayList<String> entrenamientos=new ArrayList<String>();


    String idplan;
    Integer idsemana;
    String identrenamiento;
    //////
    TextView descripcionPlan;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_planesdiarios);
        //Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);

        identrenamiento="";

        Intent intent = getIntent();
        Bundle extras = intent.getExtras();
        if(extras != null)
        {
            identrenamiento =  (String) extras.get("identrenamiento");
            idsemana = (Integer) extras.get("idsemana");

            idplan =  (String) extras.get("idplan");

        }




        PlanesEntrenamiento plan = PlanesEntrenamiento.findById(PlanesEntrenamiento.class, Integer.parseInt(idplan));
        String fecha=plan.getFecha();

        descripcionPlan = (TextView) findViewById(R.id.descripcionPlan);


        // Obtenemos el tiempo
        String strtiempo="", strhoras="", strminutos="";
        if (!plan.getTiempoobjetivo().equals("")) {
            int horas = Integer.parseInt("0"+plan.getTiempoobjetivo().split(":")[0]);
            int minutos = Integer.parseInt("0"+plan.getTiempoobjetivo().split(":")[1]);
            if (horas != 0 || minutos != 0) {
                if (horas != 0)
                    strhoras = horas + " " + this.getString(R.string.horas);
                if (strhoras != "" && minutos != 0)
                    strminutos = " "+this.getString(R.string.y) + " " + minutos + " " + this.getString(R.string.minutos);
                else
                    strminutos = " " + minutos + " " + this.getString(R.string.minutos);

                strtiempo = this.getString(R.string.en) + " " + strhoras + strminutos;

            }
        }

        descripcionPlan.setText(plan.getNombreplan()+" ("+ plan.getFecha()+ ") "+ strtiempo);


        DateFormat format = new SimpleDateFormat("yyyy/MM/dd", Locale.ENGLISH);
        Date date= null;
        try {
            date = format.parse(fecha);
        } catch (ParseException e) {
            e.printStackTrace();
        }


       Entrenamientos entrenamientoSemanal = Entrenamientos.findById(Entrenamientos.class, Integer.parseInt(identrenamiento));

        // Con el replace conseguimos que no nos de error si no hay plan diario.
        String entrenamientodiario[]=entrenamientoSemanal.getEntrenamiento().replace("|","| ").split("\\|");

        List<Entrenamientos> entrenamientosSemanales= Entrenamientos.find(Entrenamientos.class, "plan = ?" ,idplan);


        String[] diasdelasemana = new String[]{ getString(R.string.domingo), getString(R.string.lunes), getString(R.string.martes), getString(R.string.miercoles), getString(R.string.jueves), getString(R.string.viernes), getString(R.string.sabado), getString(R.string.domingo), getString(R.string.lunes) };

        if (!entrenamientosSemanales.isEmpty()) {
            for (int i =0; i < 7; i++ ) {

                ids.add(new Long(i));

                Calendar calendar = Calendar.getInstance();

                calendar.setTime(date);
                calendar.add(Calendar.DAY_OF_YEAR, -(entrenamientosSemanales.size()-idsemana)*7+1+i);
                SimpleDateFormat format1 = new SimpleDateFormat("yyyy-MM-dd");

                int dia = calendar.get(Calendar.DAY_OF_WEEK);
                String date1 = format1.format(calendar.getTime());

                dias.add(diasdelasemana[dia-1]+" "+date1);
                entrenamientos.add(entrenamientodiario[i]);

            }

        }




        //// Listado plan diario

        final ListView lista = (ListView) findViewById(R.id.listView1);
        adapter = new ListViewAdapterPlanesDiarios(this, ids, dias, entrenamientos);
        lista.setAdapter(adapter);

        lista.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView adapterView, View view, int i, long l) {

            }
        });


    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.planesdiarios_activity_menu, menu);
        return super.onCreateOptionsMenu(menu);


    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.action_modificar:
                Intent intent = new Intent(PlanesDiarios.this, NuevaSemana.class);
                intent.putExtra("idplan", idplan);
                intent.putExtra("identrenamiento", identrenamiento);
                startActivity(intent);
                return true;

            case R.id.action_borrar:


                AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(PlanesDiarios.this);

                // set title
                alertDialogBuilder.setTitle(getString(R.string.borrar_plan_semanal));

                // set dialog message
                alertDialogBuilder
                        .setMessage(getString(R.string.borrar_plan_semanal))
                        .setCancelable(false)
                        .setPositiveButton(getString(R.string.si),new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog,int id) {
                            // Si pulsamos si borramos el plan
                                Entrenamientos entrenamiento = Entrenamientos.findById(Entrenamientos.class, Integer.parseInt(identrenamiento));
                                entrenamiento.delete();

                                Intent intent = new Intent(PlanesDiarios.this, PlanesSemanales.class);
                                intent.putExtra("idplan",idplan);
                                startActivity(intent);

                            }
                        })
                        .setNegativeButton(getString(R.string.no),new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog,int id) {
                                // Si pulsamos no se cierra el dialogbox sin hacer nada
                                dialog.cancel();
                            }
                        });

                // Visualiza la alerta
                AlertDialog alertDialog = alertDialogBuilder.create();
                alertDialogBuilder.show();

                return true;

            case R.id.action_listado:
                Intent intent2 = new Intent(PlanesDiarios.this, Planes.class);
                startActivity(intent2);
                return true;

            case R.id.action_salir:
                Intent intent3 = new Intent(PlanesDiarios.this, Validar.class);
                startActivity(intent3);
                return true;

            default:
                return super.onOptionsItemSelected(item);

        }
    }
}



