package com.trainerplan.trainerplan;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.trainerplan.trainerplan.modelo.Entrenamientos;
import com.trainerplan.trainerplan.modelo.PlanesEntrenamiento;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Locale;

public class PlanesSemanales extends AppCompatActivity {

    /////////////// LISTADO DE PLANES
    ListViewAdapterPlanesSemanales adapter;

    ArrayList<Long> ids=new ArrayList<Long>();
    ArrayList<Integer> semanas=new ArrayList<Integer>();
    ArrayList<String> entrefechas=new ArrayList<String>();

    public String idplan="";

    TextView descripcionPlan;
    String descripcionlantxt;
    String idusuario, sesion, email;
    //////

    //Nos permite almacenar de forma persistentes los datos de los usuarios
    SharedPreferences prefs;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_planessemanales);
        //Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);



        SharedPreferences prefs = getSharedPreferences("MisPreferencias", Context.MODE_PRIVATE);
        idusuario = (prefs.getString("idusuario", ""));
        sesion = (prefs.getString("sesion", ""));
        email = (prefs.getString("email", ""));




        Intent intent = getIntent();
        Bundle extras = intent.getExtras();
        if(extras != null)
        {
            idplan =  (String) extras.get("idplan");
        }





        PlanesEntrenamiento plan = PlanesEntrenamiento.findById(PlanesEntrenamiento.class, Integer.parseInt(idplan));
        String fecha=plan.getFecha();

        descripcionPlan = (TextView) findViewById(R.id.descripcionPlan);

        //String strtiempo=" "+ getString(R.string.en) +" "+plan.getTiempoobjetivo().split(":")[0]+" "+ getString(R.string.horas) +" "+ getString(R.string.y) +" "+plan.getTiempoobjetivo().split(":")[1]+" "+ getString(R.string.minutos);


        String strtiempo="", strhoras="", strminutos="";
        // En lugar de utilizar 3 líneas pongo todos los datos en 1.
        if (!plan.getTiempoobjetivo().equals("")) {
            int horas = Integer.parseInt("0"+plan.getTiempoobjetivo().split(":")[0]);
            int minutos = Integer.parseInt("0"+plan.getTiempoobjetivo().split(":")[1]);
            if (horas != 0 || minutos != 0) {
                if (horas != 0)
                    strhoras = horas + " " + this.getString(R.string.horas);
                if (strhoras != "" && minutos != 0)
                    strminutos = " "+this.getString(R.string.y) + " " + minutos + " " + this.getString(R.string.minutos);
                else
                    strminutos = " " + minutos + " " + this.getString(R.string.minutos);

                strtiempo = this.getString(R.string.en) + " " + strhoras + strminutos;

            }
        }

        descripcionPlan.setText(plan.getNombreplan()+" ("+ plan.getFecha()+ ") "+ strtiempo);

        DateFormat format = new SimpleDateFormat("yyyy/MM/dd", Locale.ENGLISH);
        Date date= null;
        try {
            date = format.parse(fecha);
        } catch (ParseException e) {
            e.printStackTrace();
        }


        // List<Entrenamientos> entrenamientosSemanales = Entrenamientos.listAll(Entrenamientos.class);
        //List<Entrenamientos> entrenamientosSemanales= Entrenamientos.find(Entrenamientos.class, "plan = ?" ,idplan, null, null, null);
        List<Entrenamientos> entrenamientosSemanales = Entrenamientos.findWithQuery(Entrenamientos.class, "SELECT * FROM Entrenamientos where plan = '"+idplan+"' ORDER BY semana ASC", null);
        // Se coge el primero de la lista de encontrados


        if (!entrenamientosSemanales.isEmpty()) {
            for (int i =0; i < entrenamientosSemanales.size(); i++ ) {

                Entrenamientos entrenamiento = entrenamientosSemanales.get(i);
                ids.add(entrenamiento.getId());
                semanas.add(entrenamiento.getSemana());


                Calendar calendar = Calendar.getInstance();
                calendar.setTime(date); // Configuramos la fecha que se recibe
                calendar.add(Calendar.DAY_OF_YEAR, -(entrenamientosSemanales.size()-i)*7+1);
                SimpleDateFormat format1 = new SimpleDateFormat("yyyy-MM-dd");
                String date1 = format1.format(calendar.getTime());

                calendar.setTime(date);
                calendar.add(Calendar.DAY_OF_YEAR, -(entrenamientosSemanales.size()-i)*7+7);
                String date2 = format1.format(calendar.getTime());
                entrefechas.add(getBaseContext().getString(R.string.del)+" "+date1+" "+getBaseContext().getString(R.string.hasta)
                        +" "+date2+" "+getBaseContext().getString(R.string.hasta2));


            }

            //}
        }


         //// Listado planes

        final ListView lista = (ListView) findViewById(R.id.listView1);

        adapter = new ListViewAdapterPlanesSemanales(this, ids, semanas, entrefechas);
        lista.setAdapter(adapter);

        lista.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView adapterView, View view, int i, long l) {
                Intent intent = new Intent(PlanesSemanales.this, PlanesDiarios.class);
                intent.putExtra("identrenamiento",ids.get(i)+"");
                intent.putExtra("idsemana",i);
                intent.putExtra("idplan",idplan);
                startActivity(intent);

            }
        });


}


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.planessemanales_activity_menu, menu);
        return super.onCreateOptionsMenu(menu);


    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.action_borrar:



                AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(PlanesSemanales.this);

                // set title
                alertDialogBuilder.setTitle(getBaseContext().getString(R.string.eliminar_plan));

                // set dialog message
                alertDialogBuilder
                        .setMessage(getBaseContext().getString(R.string.desea_borrar_plan))
                        .setCancelable(false)
                        .setPositiveButton(getBaseContext().getString(R.string.si),new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog,int id) {
                                // if this button is clicked, close
                                // current activity
                                //PlanesSemanales.this.finish();
                                PlanesEntrenamiento plan = PlanesEntrenamiento.findById(PlanesEntrenamiento.class, Integer.parseInt(idplan));
                                plan.delete();

                                //List<Entrenamientos> entrenamientos = Entrenamientos.listAll(Entrenamientos.class);
                                List<Entrenamientos> entrenamientos = Entrenamientos.find(Entrenamientos.class, "plan = ?" ,idplan);

                                for (int i=0; i < entrenamientos.size(); i++) {
                                    Entrenamientos entrenamiento=entrenamientos.get(i);
                                    entrenamiento.delete();
                                }

                                Intent intent = new Intent(PlanesSemanales.this, Planes.class);
                                startActivity(intent);

                            }
                        })
                        .setNegativeButton(getBaseContext().getString(R.string.no),new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog,int id) {
                                // if this button is clicked, just close
                                // the dialog box and do nothing
                                dialog.cancel();
                            }
                        });

                // create alert dialog
                AlertDialog alertDialog = alertDialogBuilder.create();
                alertDialogBuilder.show();


                return true;


            case R.id.action_nuevo:
                Intent intent5 = new Intent(PlanesSemanales.this, NuevaSemana.class);
                intent5.putExtra("idplan", idplan);
                intent5.putExtra("identrenamiento", "");
                startActivity(intent5);
                return true;


            case R.id.action_modificar:
                Intent intent2 = new Intent(PlanesSemanales.this, Nuevo.class);
                intent2.putExtra("idplan", idplan);
                startActivity(intent2);
                return true;

            case R.id.action_compartir:


                AlertDialog.Builder alertDialogBuilder2 = new AlertDialog.Builder(PlanesSemanales.this);
                // set title
                alertDialogBuilder2.setTitle(getBaseContext().getString(R.string.compartir_plan));
                // set dialog message
                alertDialogBuilder2
                        .setMessage(getBaseContext().getString(R.string.desea_compartir))
                        .setCancelable(false)
                        .setPositiveButton(getBaseContext().getString(R.string.si),new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog,int id) {
                                // if this button is clicked, close
                                // current activity
                                //PlanesSemanales.this.finish();
                                PlanesEntrenamiento plan = PlanesEntrenamiento.findById(PlanesEntrenamiento.class, Integer.parseInt(idplan));
                                List<Entrenamientos> entrenamientos = Entrenamientos.find(Entrenamientos.class, "plan = ?" ,idplan);
                                String jsonentrenamientos="";
                                for (int i=0; i < entrenamientos.size(); i++) {
                                    Entrenamientos entrenamiento = entrenamientos.get(i);
                                    if (i == 0) {
                                        jsonentrenamientos = "{ \"semana\": \"" + entrenamiento.getSemana() + "\", \"entrenamiento\": \"" + entrenamiento.getEntrenamiento() + "\" }";
                                    } else {
                                        jsonentrenamientos = jsonentrenamientos+", { \"semana\": \"" + entrenamiento.getSemana() + "\", \"entrenamiento\": \"" + entrenamiento.getEntrenamiento() + "\" }";

                                    }
                                }
                                String json=" [{ \"idplan\": \""+plan.getIdplan()+"\", \"nombre\": \""+plan.getNombreplan()+"\", \"fecha\": \""+plan.getFecha()+"\", \"tiempo\": \""+plan.getTiempoobjetivo()+"\", \"tipo\": \""+plan.getTipo()+"\", \"lang\": \""+plan.getLang()+"\", \"entrenamientos\": ["+jsonentrenamientos+"]}]";
                                String lang = Locale.getDefault().getLanguage().toString();
                                Integer tipo=plan.getTipo();




                                if (idusuario.isEmpty()) {


                                    /// Si no soy usuario registrado no puedo compartir
                                    AlertDialog.Builder alertDialogBuilder3 = new AlertDialog.Builder(PlanesSemanales.this);
                                    // set title
                                    alertDialogBuilder3.setTitle(getBaseContext().getString(R.string.para_compartir_registrado));
                                    // set dialog message
                                    alertDialogBuilder3
                                            .setMessage(getBaseContext().getString(R.string.deseas_autentificarte))
                                            .setCancelable(false)
                                            .setPositiveButton(getBaseContext().getString(R.string.si),new DialogInterface.OnClickListener() {
                                                public void onClick(DialogInterface dialog, int id) {
                                                    // if this button is clicked, close
                                                    // current activity
                                                    Intent intent6 = new Intent(PlanesSemanales.this, Validar.class);
                                                    startActivity(intent6);
                                                }
                                            })


                                            .setNegativeButton(getBaseContext().getString(R.string.no),new DialogInterface.OnClickListener() {
                                                    public void onClick(DialogInterface dialog,int id) {
                                                        // if this button is clicked, just close
                                                        // the dialog box and do nothing
                                                        dialog.cancel();
                                                    }
                                                });
                                    // create alert dialog
                                    AlertDialog alertDialog2 = alertDialogBuilder3.create();
                                    alertDialogBuilder3.show();



                                    ///// Fin pregunta registro usuario

                                }
                                else {

                                    if (new CheckearConexion(PlanesSemanales.this).isNetworkAvailable()) {
                                        compartirPlan compartirPlan = new compartirPlan(PlanesSemanales.this);
                                        // Obtenemos la url base
                                        SharedPreferences prefs = getSharedPreferences("MisPreferencias", Context.MODE_PRIVATE);
                                        String urlbase;
                                        urlbase = (prefs.getString("urlbase", ""));
                                        compartirPlan.execute(urlbase+"compartir.php", idplan.toString(), plan.getNombreplan(), plan.getFecha(), plan.getTiempoobjetivo(), tipo.toString(), idusuario, email, sesion, lang, json);

                                    } else {
                                        Toast.makeText(PlanesSemanales.this, getString(R.string.error_conexion), Toast.LENGTH_LONG).show();
                                    }

                                }

                            }
                        })
                        .setNegativeButton(getBaseContext().getString(R.string.no),new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog,int id) {
                                // if this button is clicked, just close
                                // the dialog box and do nothing
                                dialog.cancel();
                            }
                        });

                // create alert dialog
                AlertDialog alertDialog2 = alertDialogBuilder2.create();
                alertDialogBuilder2.show();


                return true;



            case R.id.action_salir:

                // Quitamos el valor de las variables guardadas de forma persistente
                prefs = getSharedPreferences("MisPreferencias", Context.MODE_PRIVATE);
                SharedPreferences.Editor editor = prefs.edit();
                editor.putString("idrespuesta", "");
                editor.putString("email", "");
                editor.putString("idusuario", "");
                editor.putString("sesion", "");
                editor.commit();
                Intent intent4 = new Intent(PlanesSemanales.this, Validar.class);
                startActivity(intent4);
                return true;

            default:
                return super.onOptionsItemSelected(item);

        }
    }

    // Elsiguiente método comparte un plan de forma asíncrona

    public class compartirPlan extends AsyncTask<String, String, String> {


        //Bara de progresión
        private ProgressDialog dialog;


        public compartirPlan(PlanesSemanales activity) {

            // Definimos la barra de progresión
            dialog = new ProgressDialog(activity);


        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            // Mostramos la barra de progresión
            dialog.setMessage(getString(R.string.compartiendo_plan));
            dialog.show();
        }


        @Override
        protected String doInBackground(String... params) {


            String urlString = params[0]; // URL to call

            String resultToDisplay = "";
            OutputStreamWriter request = null;

            InputStream in = null;
            try {

                URL url = new URL(urlString);

                String parameters = "idplan=" + params[1] + "&nombre=" + params[2] + "&fecha=" + params[3] + "&tiempo=" + params[4]  + "&tipo=" + params[5] +  "&idusuario=" + params[6] +  "&email=" + params[7] +  "&sesion=" + params[8] + "&lang=" + params[9] + "&json=" + params[10];

                HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
                urlConnection.setDoOutput(true);
                urlConnection.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
                urlConnection.setRequestMethod("POST");

                request = new OutputStreamWriter(urlConnection.getOutputStream());
                request.write(parameters);
                request.flush();
                request.close();


                in = new BufferedInputStream(urlConnection.getInputStream());

                BufferedReader br = new BufferedReader(new InputStreamReader(in));
                String inputLine = "";
                while ((inputLine = br.readLine()) != null) {
                    resultToDisplay += inputLine;

                }

                resultToDisplay=trataJSON(resultToDisplay);





            } catch (Exception e) {

                System.out.println(e.getMessage());


                return e.getMessage();

            }


            return resultToDisplay;
        }


        @Override
        protected void onPostExecute(String result) {

            // Finalizamos la barra de progresión
            if (dialog.isShowing()) {
                dialog.dismiss();
            }

            if (result.equals("1")) {
                Toast.makeText(getBaseContext(), getString(R.string.plan_compartido), Toast.LENGTH_LONG).show();

            } else {
                Toast.makeText(getBaseContext(), getString(R.string.plan_no_compartido), Toast.LENGTH_LONG).show();
            }


        }
    }


    private String trataJSON(String result) {


        String idrespuesta="", respuesta="";

        JSONArray jsonArray = null;
        try {
            jsonArray = new JSONArray(result);
            for (int i = 0; i < jsonArray.length(); i++) {
                JSONObject obj1 = jsonArray.getJSONObject(i);
                idrespuesta = (String) obj1.get("idrespuesta");
                respuesta = (String) obj1.get("respuesta");

            }



        } catch (JSONException e) {
            e.printStackTrace();
        }

        return idrespuesta;

    }
}



