package com.trainerplan.trainerplan;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import com.facebook.stetho.Stetho;
import com.orm.SugarApp;


import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Locale;


public class Registro extends AppCompatActivity {


    private String emailtxt, passwordtxt, nombreusuariotxt;
    private EditText email, password, nombreusuario;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_registro);


        // Inicializamos stetho para poder ver la BBDD desde chrome://inspect
        Stetho.initializeWithDefaults(this);


        Button entrar = (Button) findViewById(R.id.entrar);
        Button registrar = (Button) findViewById(R.id.registrar);
        Button sinregistrar = (Button) findViewById(R.id.entrarsin);


        email = (EditText) findViewById(R.id.email);
        nombreusuario = (EditText) findViewById(R.id.nombreusuario);
        password = (EditText) findViewById(R.id.password);


        registrar.setBackgroundColor(Color.RED);
        registrar.setFocusableInTouchMode(true);
        registrar.requestFocus();


        registrar.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View view) {



                emailtxt=email.getText().toString();
                passwordtxt=password.getText().toString();
                nombreusuariotxt=nombreusuario.getText().toString();



                if (nombreusuariotxt.isEmpty()) {
                    nombreusuario.requestFocus();
                    Toast.makeText(Registro.this, getString(R.string.usuario_obligatorio), Toast.LENGTH_SHORT).show();
                } else if (emailtxt.isEmpty()) {
                    email.requestFocus();
                    Toast.makeText(Registro.this, getString(R.string.email_obligatorio), Toast.LENGTH_SHORT).show();
                } else if (!android.util.Patterns.EMAIL_ADDRESS.matcher(emailtxt).matches()) {
                    Toast.makeText(Registro.this, getString(R.string.correo_no_valido), Toast.LENGTH_SHORT).show();
                    email.requestFocus();
                } else if (passwordtxt.isEmpty()) {
                    password.requestFocus();
                    Toast.makeText(Registro.this, getString(R.string.password_obligatorio), Toast.LENGTH_SHORT).show();

                } else {


                    if (new CheckearConexion(Registro.this).isNetworkAvailable()) {
                        String lang = Locale.getDefault().getLanguage();
                        Registro.validarUsuario obtenerplan = new Registro.validarUsuario(Registro.this);
                        // Obtenemos la url base
                        SharedPreferences prefs = getSharedPreferences("MisPreferencias", Context.MODE_PRIVATE);
                        String urlbase;
                        urlbase = (prefs.getString("urlbase", ""));
                        obtenerplan.execute(urlbase+"registro.php", emailtxt, nombreusuariotxt, passwordtxt,lang);
                    } else {
                        Toast.makeText(Registro.this, getString(R.string.error_conexion), Toast.LENGTH_LONG).show();
                    }
                }


            }

        });



        entrar.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View view) {
                Intent intent = new Intent(Registro.this, Validar.class);
                startActivity(intent);
            }

        });


        sinregistrar.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View view) {
                Intent intent = new Intent(Registro.this, Planes.class);
                startActivity(intent);
            }

        });




    }



    public class validarUsuario extends AsyncTask<String, String, String> {


        //Bara de progresión
        private ProgressDialog dialog;


        public validarUsuario (Registro activity) {

            // Definimos la barra de progresión
            dialog = new ProgressDialog(activity);


        }

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            // Mostramos la barra de progresión
            dialog.setMessage(getString(R.string.solicitando_registro));
            dialog.show();


        }


        @Override
        protected String doInBackground(String... params) {



            String urlString = params[0]; // URL to call

            String resultToDisplay = "";
            OutputStreamWriter request = null;

            String respuesta;

            InputStream in = null;
            try {

                URL url = new URL(urlString);
                String parameters = "email="+params[1]+"&usuario="+params[2]+"&password="+params[3]+"&lang="+params[4];


                HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
                urlConnection.setDoOutput(true);
                urlConnection.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
                urlConnection.setRequestMethod("POST");

                request = new OutputStreamWriter(urlConnection.getOutputStream());
                request.write(parameters);
                request.flush();
                request.close();



                in = new BufferedInputStream(urlConnection.getInputStream());

                BufferedReader br = new BufferedReader(new InputStreamReader(in));
                String inputLine = "";
                while ((inputLine = br.readLine()) != null) {
                    resultToDisplay+=inputLine;

                }


                respuesta = trataJSON(resultToDisplay);


            } catch (Exception e) {

                System.out.println(e.getMessage());

                return e.getMessage();

            }

            return respuesta;


        }


        @Override
        protected void onPostExecute(String result) {

            // Finalizamos la barra de progresión
            if (dialog.isShowing()) {
                dialog.dismiss();
            }


            if (result.equals("0")) {
                Toast.makeText(getBaseContext(), getString(R.string.usuario_ya_existe), Toast.LENGTH_LONG).show();

            } else  if (result.equals("1")) {
                Toast.makeText(getBaseContext(), getString(R.string.registro_usuario_correcto), Toast.LENGTH_LONG).show();
            }
            else  if (result.equals("2")) {
                Toast.makeText(getBaseContext(), getString(R.string.error), Toast.LENGTH_LONG).show();
            } else {
                Toast.makeText(Registro.this, getString(R.string.error_conexion_servidor)+" "+ result, Toast.LENGTH_LONG).show();

            }



        }
    }


    private String trataJSON(String result) {

        String idrespuesta="", respuesta="";


        JSONArray jsonArray = null;
        try {
            jsonArray = new JSONArray(result);
            for (int i = 0; i < jsonArray.length(); i++) {
                JSONObject obj1 = jsonArray.getJSONObject(i);
                 idrespuesta = (String) obj1.get("idrespuesta");
                 respuesta = (String) obj1.get("respuesta");

            }

        } catch (JSONException e) {
            e.printStackTrace();
        }

        return idrespuesta;

    }



}
